/********************************************************************/
/*	iCAM Common Source												*/
/********************************************************************/
#include "StdAfx.h"
#include "SVIComm.h"
#include "SVIPluginComm.h"

ULONG	gulHeight;

/********************************************************************/
/*	֐hcFIsDatFile												*/
/*	֐́FDATt@C										*/
/*	@\TvFDATt@C̃wb_擾At@C̔ʁi8Bit	*/
/*			@܂16Bitjs									*/
/*  ߂l  F8Bit:DEF_8BITSDAT / 16Bit:DEF_16BITSDAT				*/
/********************************************************************/
int IsDatFile(
					CString& strFilePath	// [IN] Datt@CpX
				)
{
	CFile	File( strFilePath, CFile::modeRead | CFile::shareDenyWrite );	// CFileIuWFNgDatt@Cт
	BYTE	pDatBuff[DATHEADERSIZE]; // Header̈
	int		iReadSize;
	int		rc;

	TRY {
		if( File.GetLength() < DATHEADERSIZE )
			return DEF_OTHERFILE;

		// Datt@Cwb_ǂݍ
		iReadSize	= File.Read( pDatBuff, DATHEADERSIZE );
	}
	CATCH( CFileException, e ) {
		// G[
		char	pstrBuff[MAX_512];

		rc	= e->GetErrorMessage( pstrBuff, MAX_512, NULL );
		if( rc != 0 ) {
			AfxMessageBox( pstrBuff );
		}

		return	DEF_ERR;
	}
	END_CATCH

	File.Close();

	if( pDatBuff[19] == DEF_8BITSDAT ) {
		// 8BitsDatt@C
		return DEF_8BITSDAT;
	}
	else if( pDatBuff[19] == DEF_16BITSDAT ) {
		// 16BitsDatt@C
		return DEF_16BITSDAT;
	}
	else {
		// ̑̃t@C
		return DEF_OTHERFILE;
	}
}	// IsDatFile End

/********************************************************************/
/*	֐hcFIsMemoryDatFile										*/
/*	֐́FDATf[^											*/
/*	@\TvFDATf[^̃wb_擾At@C̔ʁi8Bit		*/
/*			@܂16Bitjs									*/
/*  ߂l  F8Bit:DEF_8BITSDAT / 16Bit:DEF_16BITSDAT				*/
/********************************************************************/
int IsMemoryDatFile(
					CString strMemoryName	// [IN] L
				)
{
	HANDLE	hMapping;
	LPBYTE	pDatData;
	short	iDatFlag;

	// DATt@CI[v
	if( OpenMapping( FILE_MAP_WRITE, &hMapping, strMemoryName ) == DEF_ERR ) {
		return DEF_ERR;
	}

	pDatData	= (LPBYTE)::MapViewOfFile( hMapping, FILE_MAP_WRITE, 0, 0, DATHEADERSIZE );

	if( pDatData == NULL ) {
		// t@C擾sAnhN[Y
		::CloseHandle( hMapping );
		return DEF_ERR;
	}

	iDatFlag	= (short)ConvEndian( pDatData + 19, sizeof( short ) );

	::UnmapViewOfFile( pDatData );

	::CloseHandle( hMapping );

	if( iDatFlag == DEF_8BITSDAT ) {
		// 8BitsDatt@C
		return DEF_8BITSDAT;
	}
	else if( iDatFlag == DEF_16BITSDAT ) {
		// 16BitsDatt@C
		return DEF_16BITSDAT;
	}
	else {
		// ̑̃t@C
		return DEF_OTHERFILE;
	}
}	// IsDatFile End

/********************************************************************/
/*	֐hcFReadDatHeader											*/
/*	֐́F16BitDatt@Cwb_擾							*/
/*	@\TvF16BitDatt@C̃wb_擾					*/
/*  ߂l  FǍ:DEF_OK / ُ:DEF_ERR						*/
/********************************************************************/
int ReadDatHeader(
						CString&		strFilePath,	// [IN]  Datt@CpX
						sDatFileHeader*	pDatHeader		// [OUT] Datwb_
					)
{
	FILE*	fp;
	int		rc;

	// 64bit warning΍ 2011/10/06
#if 0
	// DATt@CI[v
	fp	= fopen( strFilePath, "rb" );
#else
	errno_t err;

	// DATt@CI[v
	if( (err  = fopen_s( &fp, strFilePath, "rb" )) !=0 )
	{
		return DEF_ERR;
	}
#endif

	rc	= (int)fread( &pDatHeader->ApplicationID[0], sizeof(char) * 10, 1, fp );				// AvP[VID
	rc	= (int)fread( &pDatHeader->version_of_firmware, sizeof(unsigned char), 1, fp );		// t@[EFÃo[Wԍ
	rc	= (int)fread( &pDatHeader->version_of_hardware, sizeof(unsigned char), 1, fp );		// n[hEFÃo[Wԍ
	rc	= (int)fread( &pDatHeader->num_of_channel, sizeof(short), 1, fp );					// 0x0001Œ
	rc	= (int)fread( &pDatHeader->compression_flag, sizeof(unsigned char), 1, fp );			// ktO
	rc	= (int)fread( &pDatHeader->num_of_scan, sizeof(long), 1, fp );						// f[^TCY
	rc	= (int)fread( &pDatHeader->data_width, sizeof(short), 1, fp );						// f[^
	rc	= (int)fread( &pDatHeader->channel_order, sizeof(short), 1, fp );					// 0x0000Œ
	rc	= (int)fread( &pDatHeader->ad_range, sizeof(short), 1, fp );							// 0x0000Œ
	rc	= (int)fread( &pDatHeader->scan_rate, sizeof(double), 1, fp );						// 0x0000000000000000Œ
	rc	= (int)fread( &pDatHeader->num_of_channel_range, sizeof(short), 1, fp );				// 0x0000Œ
	rc	= (int)fread( &pDatHeader->start_date, sizeof(char) * 8, 1, fp );					// ^Jn
	rc	= (int)fread( &pDatHeader->start_time, sizeof(char) * 8, 1, fp );					// ^Jn
	rc	= (int)fread( &pDatHeader->start_millsec, sizeof(char) * 3, 1, fp );					// ^Jn(ms)
	rc	= (int)fread( &pDatHeader->reserved, sizeof(char) * 2, 1, fp );						// 0x0000Œ
	rc	= (int)fread( &pDatHeader->offset, sizeof(long), 1, fp );							// 摜f[^ւ̃ItZbg(0x00000000Œ)

	fclose( fp );

	if( rc < 1 ) {
		return DEF_ERR;
	}

	return DEF_OK;
}	// ReadDatHeader End

/********************************************************************/
/*	֐hcFReadMemoryDatHeader									*/
/*	֐́FDatf[^wb_擾									*/
/*	@\TvFDatf[^̃wb_擾							*/
/*  ߂l  FǍ/ُ											*/
/********************************************************************/
int ReadMemoryDatHeader(
						CString			strMemoryName,	// [IN]  L
						sDatFileHeader*	pDatHeader		// [OUT] Datwb_
					)
{
	HANDLE	hMapping;
	LPBYTE	pDatData;
	int		iAddress;

	// DATt@CI[v
	if( OpenMapping( FILE_MAP_WRITE, &hMapping, strMemoryName ) == DEF_ERR ) {
		return DEF_ERR;
	}

	pDatData	= (LPBYTE)::MapViewOfFile( hMapping, FILE_MAP_WRITE, 0, 0, DATHEADERSIZE );

	if( pDatData == NULL ) {
		// t@C擾sAnhN[Y
		::CloseHandle( hMapping );
		return DEF_ERR;
	}

	memcpy( &pDatHeader->ApplicationID[0], pDatData, sizeof(char) * 10 );								// AvP[VID
	iAddress	= sizeof(char) * 10;
	memcpy( &pDatHeader->version_of_firmware, pDatData + iAddress, sizeof(unsigned char) );				// t@[EFÃo[Wԍ
	iAddress	+= sizeof(unsigned char);
	memcpy( &pDatHeader->version_of_hardware, pDatData + iAddress, sizeof(unsigned char) );				// n[hEFÃo[Wԍ
	iAddress	+= sizeof(unsigned char);
	pDatHeader->num_of_channel	= (short)ConvEndian( pDatData + iAddress, sizeof( short ) );			// 0x0001Œ
	iAddress	+= sizeof(short);
	memcpy( &pDatHeader->compression_flag, pDatData + iAddress, sizeof(unsigned char) );				// ktO
	iAddress	+= sizeof(unsigned char);
	pDatHeader->num_of_scan	= (long)ConvEndian( pDatData + iAddress, sizeof( long ) );					// f[^TCY
	iAddress	+= sizeof(long);
	pDatHeader->data_width	= (short)ConvEndian( pDatData + iAddress, sizeof( short ) );				// f[^
	iAddress	+= sizeof(short);
	pDatHeader->channel_order	= (short)ConvEndian( pDatData + iAddress, sizeof( short ) );			// 0x0000Œ
	iAddress	+= sizeof(short);
	pDatHeader->ad_range	= (short)ConvEndian( pDatData + iAddress, sizeof( short ) );				// 0x0000Œ
	iAddress	+= sizeof(short);
	pDatHeader->scan_rate	= (double)ConvEndian( pDatData + iAddress, sizeof( double ) );				// 0x0000000000000000Œ
	iAddress	+= sizeof(double);
	pDatHeader->num_of_channel_range	= (short)ConvEndian( pDatData + iAddress, sizeof( short ) );	// 0x0000Œ
	iAddress	+= sizeof(short);
	memcpy( &pDatHeader->start_date, pDatData + iAddress, sizeof(char) * 8 );							// ^Jn
	iAddress	+= sizeof(char) * 8;
	memcpy( &pDatHeader->start_time, pDatData + iAddress, sizeof(char) * 8 );							// ^Jn
	iAddress	+= sizeof(char) * 8;
	memcpy( &pDatHeader->start_millsec, pDatData + iAddress, sizeof(char) * 3 );						// ^Jn(ms)
	iAddress	+= sizeof(char) * 3;
	memcpy( &pDatHeader->reserved, pDatData + iAddress, sizeof(char) * 2 );								// 0x0000Œ
	iAddress	+= sizeof(char) * 2;
	pDatHeader->offset	= (long)ConvEndian( pDatData + iAddress, sizeof( long ) );						// 0x00000000Œ

	::UnmapViewOfFile( pDatData );

	::CloseHandle( hMapping );

	return DEF_OK;
}	// ReadDatHeader End

/********************************************************************/
/*	֐hcFGetExecHandle											*/
/*	֐́Fnh擾											*/
/*	@\TvFw肳ꂽs̃nh擾						*/
/*  ߂l  FFnh ُFNULL								*/
/********************************************************************/
CWnd* GetExecHandle(
					CString strClassName,	// [IN] NX
					CString strFileName )	// [IN] ^Cg
{
	// NAvP[Ṽgbvx̃EBhE̎擾
	CWnd*	pPrevWnd = CWnd::GetDesktopWindow()->GetWindow( GW_CHILD );

	char	findClass[MAX_256];	// EBhEENX
	char	findTitle[MAX_512];	// EBhEE^Cg

	while(pPrevWnd)
	{
		GetClassName(pPrevWnd->m_hWnd, findClass, sizeof( findClass ));
		pPrevWnd->GetWindowText( findTitle, sizeof( findTitle ));

		// NXƃ^CgrASVIViewł΁AbZ[W𑗕t
		if( (strcmp( findTitle, strFileName ) == 0) || (strcmp( findClass, strClassName ) == 0) )
		{
			return pPrevWnd;
		}
		//AvP[Ṽgbvx̃EBhE̎擾
		pPrevWnd = pPrevWnd->GetWindow( GW_HWNDNEXT );
	}

	return NULL;
}	// GetExecHandle End

/********************************************************************/
/*	֐hcFWinExecEx												*/
/*	֐́FAvP[Vs									*/
/*	@\TvFw肳ꂽAvP[Vs܂				*/
/*  ߂l  F:DEF_OK / ُ:DEF_ERR							*/
/********************************************************************/
int WinExecEx(
				LPCSTR	strFileName,	// [IN] R}hCւ̃|C^
				UINT	uCmdShow )		// [IN] EBhE̕\
{
	UINT	rc;
	CString	strMessage;

	// w肳ꂽt@C̎s
	rc	= WinExec( strFileName, uCmdShow );

	if( rc < 32 ) {
		// G[
		TRACE( "WinExec Error\n" );
		strMessage.Format( MSG_ERR_WINEXEC, strFileName );
		TRACE( strMessage );
		return DEF_ERR;
	}

	return DEF_OK;
}	// WinExecEx End

/********************************************************************/
/*	֐hcFDeleteFile											*/
/*	֐́Fwt@C폜										*/
/*	@\TvFw肳ꂽfBNg̎w肳ꂽt@CQ폜	*/
/*  ߂l  F														*/
/********************************************************************/
void DeleteFile(
				CString strFileName,		// [IN] t@C
				CString strDir )			// [IN] fBNg
{
	CFileFind	finder;
	CString		strBuff;
	BOOL		FndEndJug = TRUE;
	// łɃfBNgꍇÃt@Cׂč폜

	strBuff.Format( "%s\\%s", strDir, strFileName );
	if( !finder.FindFile( strBuff ) )
		return;

	while(FndEndJug) {
		//
		FndEndJug = finder.FindNextFile();

		// "." , ".."𖳎
		if(finder.IsDots())
			continue;

		//ʂ̔
		if(finder.IsDirectory()) {
			// TuEfBNg邽߂̍ċAĂяo
			DeleteFile( strFileName, finder.GetFilePath() );
			RemoveDirectory( strFileName );
		}
		else
			DeleteFile( finder.GetFilePath() );
	}
}	// DeleteFile End

/********************************************************************/
/*	֐hcFSetTime												*/
/*	֐́FݎԂ̎擾										*/
/*	@\TvFݎԂ擾AʎԂZbg			*/
/*  ߂l  F														*/
/********************************************************************/
void SetTime( CString& strTime )
{
	SYSTEMTIME		SystemTime;

	GetLocalTime( &SystemTime );

	strTime.Format( "%02d_%02d_%02d_%02d_%02d_%02d_%03d",
							SystemTime.wYear % 100,
							SystemTime.wMonth,
							SystemTime.wDay,
							SystemTime.wHour,
							SystemTime.wMinute,
							SystemTime.wSecond,
							SystemTime.wMilliseconds );			// Second


}	// SetTime End

#if 0
/********************************************************************/
/*	֐hcFCalcPadding											*/
/*	֐́FpfBOvZ										*/
/*	@\TvF摜̃pfBOvZ							*/
/*  ߂l  F쐬/ُ											*/
/********************************************************************/
DWORD CalcPadding( DWORD dwXSize )
{
	DWORD	dwPadding;

	dwPadding	= 4 - ( ( dwXSize * RGB24LENGTH ) % 4 );
	if( dwPadding == 4 ) {
		dwPadding	= 0;
	}

	return dwPadding;
}	// CalcPadding End
#endif

/********************************************************************/
/*	֐hcFConvInteger											*/
/*	֐́Ff[^ϊ											*/
/*	@\TvFf[^ϊ										*/
/*  ߂l  Fϊl											*/
/********************************************************************/
int ConvInteger( LPBYTE pData, int ReadSize )
{
	char	strBuff[MAX_32];

	memcpy( strBuff, pData, ReadSize );
	*( strBuff + ReadSize )	= NULL;

	return atoi( strBuff );
} // ConvInteger End

/********************************************************************/
/*	֐hcFConvDouble											*/
/*	֐́Ff[^ϊ											*/
/*	@\TvFf[^ϊ										*/
/*  ߂l  Fϊl											*/
/********************************************************************/
double ConvDouble( LPBYTE pData, int ReadSize )
{
	char	strBuff[MAX_32];

	memcpy( strBuff, pData, ReadSize );
	*( strBuff + ReadSize )	= NULL;

	return atof( strBuff );
} // ConvDouble End

/********************************************************************/
/*	֐hcFConvEndian											*/
/*	֐́FGfBAϊ										*/
/*	@\TvFGfBAϊ										*/
/*  ߂l  Fϊl											*/
/********************************************************************/
DWORD ConvEndian( LPBYTE pData, int ReadSize )
{
	DWORD	dwBuff;
	int		i;
	int		j;

	dwBuff	= 0;

	for( i = ReadSize - 1, j = 0 ; i >= 0 ; i--, j++ ) {
		dwBuff	+= *( pData + i ) << 8 * i;
	}

	return dwBuff;
} // ConvEndian End

/********************************************************************/
/*	֐hcFCalcDibSize											*/
/*	֐́F摜TCYvZ										*/
/*	@\TvF摜̃TCYvZ								*/
/*  ߂l  F摜TCY											*/
/********************************************************************/
DWORD CalcDibSize( DWORD dwXSize, DWORD dwYSize, double dZoomRate )
{
	DWORD	dwDibLength;

	// ؂o摜̃pfBO
	DWORD dwDataPadding	= CalcPadding( (DWORD)( (double)dwXSize * dZoomRate ) );

	// ؂o摜1CTCYisNZTCYj
	double dLineSize	= (double)dwXSize * dZoomRate * (double)RGB24LENGTH + (double)dwDataPadding;

	// ؂o摜TCYisNZTCYj
	dwDibLength	= (DWORD)( dLineSize * (double)dwYSize * dZoomRate );

	return dwDibLength;
} // CalcDibSize End


#ifdef	_DEF_LOGWRT
char	LOGstr[512];
void	LOGwrt( char *str )
{
static	FILE*	LOGfp	= NULL;
	char	LOGfile[MAX_128];		// Ot@C

	char	szExecPath[ MAX_FILEPATH ];
	char	szDrive	[ MAX_16 ];
	char	szDir	[ MAX_FILEPATH ];
	char	szFName	[ MAX_FILEPATH ];

	// clock_t	clock;
	// tm		*tmbuf;
	char	datetime[MAX_512];
	CString	strFile;

	time_t timer;
	struct tm *t_st;

#if 0
	clock	= time( 0 );
	tmbuf	= localtime( &clock );
#endif

	time(&timer);
	t_st = localtime(&timer);

	sprintf( datetime, "%04d/%02d/%02d %02d:%02d:%02d",
		t_st->tm_year + 1900,
		t_st->tm_mon + 1,
		t_st->tm_mday,
		t_st->tm_hour,
		t_st->tm_min,
		t_st->tm_sec );

	::GetModuleFileName( AfxGetInstanceHandle(), szExecPath, MAX_FILEPATH );
	_splitpath( szExecPath, szDrive, szDir, szFName, NULL );

	sprintf( LOGfile, "%s%s\\%s.log", szDrive, szDir, szFName );
	if( LOGfp == NULL ) 
		LOGfp = fopen( LOGfile, "w" );
	else if ( ( LOGfp = fopen( LOGfile, "r+" ) ) == NULL && ( LOGfp = fopen( LOGfile, "w" ) ) == NULL ) 
		return;

	fseek( LOGfp, 0, SEEK_END );

	if	( LOGfp == NULL ) {
		return;
	}

	fprintf( LOGfp, "%s %s", datetime, str );
	fclose( LOGfp );
	return;
}
#endif		// _DEF_LOGWRT
